=== debian/changelog ===
openjdk-9 (9~b114-0ubuntu1) xenial; urgency=medium

  * OpenJDK 9, b114.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Apr 2016 21:02:34 +0200

openjdk-9 (9~b113-1) experimental; urgency=medium

  * OpenJDK 9, b113.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Apr 2016 20:58:18 +0200

openjdk-9 (9~b112-3) experimental; urgency=medium

  * Fix zero builds, apply proposed patch for JDK-8153275.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 01 Apr 2016 18:39:09 +0200

openjdk-9 (9~b112-2) experimental; urgency=medium

  * OpenJDK 9, b112.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 31 Mar 2016 15:44:43 +0200

openjdk-9 (9~b107-1) experimental; urgency=medium

  * OpenJDK 9, b107.
  * Build-depend on openjdk-9-jdk-headless <cross>.
  * Build with GCC 5 on mips*.
  * Split out an openjdk-9-jdk-headless package.
  * Update libgconf/libgnome jre recommendations. Addresses: #813943.
  * Update package reference in README. Addresses: #814605.
  * Add french translation for policytool desktop file. Addresses: #813851.
  * Install app icons again.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 27 Feb 2016 11:55:04 +0100

openjdk-9 (9~b102-1) experimental; urgency=medium

  * OpenJDK 9, b102.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 26 Jan 2016 13:33:16 +0100

openjdk-9 (9~b101-2ubuntu2) xenial; urgency=medium

  * Don't build zero on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 17 Jan 2016 11:17:19 +0100

openjdk-9 (9~b101-2ubuntu1) xenial; urgency=medium

  * Ignore installing jsadebugd.1.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 17 Jan 2016 10:33:06 +0100

openjdk-9 (9~b101-2) experimental; urgency=medium

  * Disable the zero build on ppc64el, currently fails to build.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 16 Jan 2016 10:30:18 +0100

openjdk-9 (9~b101-1) experimental; urgency=medium

  * OpenJDK 9, b101.
  * Fix cross builds.
  * Build again using GCC 4.9 on mips*, fails to build with GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 15 Jan 2016 12:25:14 +0100

openjdk-9 (9~b96-1) experimental; urgency=medium

  * OpenJDK 9, b96.
  * openjdk-9-jdk: Fix typo in sdk provides. Addresses: #803150.
  * Build using giflib 5.
  * Build using GCC 5 everywhere.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 13 Dec 2015 17:45:17 +0100

openjdk-9 (9~b94-1) experimental; urgency=medium

  * OpenJDK 9, b94.
  * Update configury for sparc64 (Steven Chamberlain). Addresses: #806202.
  * Fix stripping packages (use bash instead of expr substring).

 -- Matthias Klose <doko@ubuntu.com>  Tue, 01 Dec 2015 11:05:27 +0100

openjdk-9 (9~b88-1) experimental; urgency=medium

  * OpenJDK 9, b88.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 25 Oct 2015 02:38:14 +0200

openjdk-9 (9~b87-2) wily; urgency=medium

  * Prefer openjdk-8-jdk for the build.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 Oct 2015 14:21:25 +0200

openjdk-9 (9~b87-1) experimental; urgency=medium

  * OpenJDK 9, b87.
  * Build the client hotspot on i386.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 19 Oct 2015 17:58:08 +0200

openjdk-9 (9~b80-2) experimental; urgency=medium

  * Fix build for armel, armhf and "unknown" zero architectures.
  * Fix build error on AArch64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 05 Sep 2015 20:16:45 +0200

openjdk-9 (9~b80-1) experimental; urgency=medium

  * OpenJDK 9, b80.
  * Fix installing the openjdk.desktop file when cautious-launch is available.
  * Define _alpha_ / _sh_ preprocessor macros instead of alpha / sh.
  * Re-enable the atk bridge for releases with a fixed atk bridge.
  * Make derivatives builds the same as the parent distro.
  * Add m68k support for Zero (Andreas Schwab).

 -- Matthias Klose <doko@ubuntu.com>  Fri, 04 Sep 2015 19:27:56 +0200

openjdk-9 (9~b74-1) experimental; urgency=medium

  * OpenJDK 9, b74.
  * Fix jdk build on x32.
  * JDK-8073754, increase stack size limits on powerpc and ppc64.
  * Configure --with-boot-jdk-jvmargs="-XX:ThreadStackSize=2240" on
    powerpc and ppc64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 27 Jul 2015 20:43:48 +0200

openjdk-9 (9~b71-1) experimental; urgency=medium

  * OpenJDK 9, b71.
  * openjdk-9-jre: Recommend the real libgconf2-4 and libgnome2-0 packages.
    Addresses: #786594.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 06 Jul 2015 17:29:39 +0200

openjdk-9 (9~b68-4) experimental; urgency=medium

  * Fix 32bit detection for the build jdk; try to build again for mips
    and mipsel (James Cowgill).
  * openjdk-jre-headless: Add dependency on the package containing the
    mountpoint binary.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Jun 2015 22:09:17 +0200

openjdk-9 (9~b68-3) experimental; urgency=medium

  * Enable bootcycle zero builds everywhere.
  * Re-enable running the testsuite.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 18 Jun 2015 23:55:33 +0200

openjdk-9 (9~b68-2) experimental; urgency=medium

  * Fix 8080684, PPC64 little-endian build.
  * Fix installation of zero based builds.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Jun 2015 19:03:31 +0200

openjdk-9 (9~b68-1) experimental; urgency=medium

  * OpenJDK 9, b68.
  * Fix the build on AArch64 (Ed Nevill).

 -- Matthias Klose <doko@ubuntu.com>  Tue, 16 Jun 2015 11:39:02 +0200

openjdk-9 (9~b64-1) experimental; urgency=medium

  * OpenJDK 9, b64.
  * Fix build error in zero.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 18 May 2015 17:30:20 +0200

openjdk-8 (8u45-b14-2) unstable; urgency=medium

  * Fix JamVM with 8u45. Closes: #766284.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 10 May 2015 19:28:41 +0200

openjdk-8 (8u45-b14-1) unstable; urgency=medium

  * Update to 8u45-b14.
  * Update AArch64 to (post) 8u45-b14.
  * Make libnss3-dev installable on precise (Thorsten Glaser). LP: #1411630.
  * Only install the openjdk-java.desktop file when using cautious-launcher.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 19 Apr 2015 16:31:44 +0200

openjdk-8 (8u40-b27-1) unstable; urgency=medium

  * Update to 8u40-b27.
  * Update AArch64 to (post) 8u40-b25.

